'Name    : IFS.PB
'Sprache : PowerBASIC
'Funktion: Darstellung von Iterierten Funktionssystemen
'Autor   : Robert Seidel
'          rseidel@ifk.uni-jena.de

$ERROR ALL OFF
$FLOAT PROCEDURE

'Datentypen (der Rest SINGLE !)
  DIM i     AS INTEGER
  DIM col   AS INTEGER
  DIM anz   AS INTEGER
  DIM speed AS INTEGER

'Auswahl des IFS-Files
IF COMMAND$ > "" THEN
  IFSName$ = COMMAND$
ELSE
  SCREEN 0
  PRINT "Namen der IFS-Files:"
  FILES "*.IFS"
  INPUT "Bitte IFS-File-Name eingeben (ohne .IFS) : ", IFSName$
END IF

'Einlesen der IFS-Daten
OPEN IFSName$ + ".IFS" FOR INPUT AS #1
  INPUT #1 , IFSName$ 'Name des Objektes
  INPUT #1 , anz      'Anzahl der affinen Abbildungen

  'Arrays fr die Tabelle dimensionieren
  DIM a(anz) , b(anz) , c(anz) , d(anz) , e(anz) , f(anz) , p(anz)

  'Laden der IFS-Tabelle
  FOR i = 1 TO anz
    INPUT #1 , a(i) , b(i) , c(i) , d(i) , e(i) , f(i) , p(i)
    'bitte bei Angaben mit letztem p = 1 entfernen
    '(bei Werten aus anderer Literatur teilweise verwendet)
    p(i) = p(i) + p(i - 1)
  NEXT

SCREEN 12
CLS
'Lesen und Setzen der Fensterwerte
INPUT #1 ,x1 , y1 , x2 , y2
WINDOW   (x1 , y1)-(x2 , y2)
PRINT "IFS-Generator von Robert Seidel 1995     Bild: " + IFSName$

RANDOMIZE TIMER 'bei jedem Start andere Zufallszahlen

'Anzeigen des IFS-Systems bis Taste gedrckt
WHILE INKEY$ = ""
  FOR speed = 1 TO 1000 'Beschleunigung
  'Auswahl der affinen Abbildung nach Wahrscheinlichkeit
    zuf = RND
    FOR i = 1 TO anz
      IF zuf <= p(i) THEN EXIT FOR
    NEXT

    'Matrix in Koordinatendarstellung
    x = a(i) * xalt + b(i) * yalt + e(i)
    y = c(i) * xalt + d(i) * yalt + f(i)

    'mgliche Frbung des IFS-Bildes
    '(kann nach Belieben gendert werden)
    col = 15
    'col = RND * 16
    'col = i
    PSET (x , y ) , col

    xalt = x
    yalt = y
  NEXT
WEND

'Pause
WHILE INKEY$ = ""
WEND

INPUT "Nocheinmal (J/N) " , a$
IF UCASE$(a$) = "J" THEN RUN